<?php

//this file gets added to the package when it gets built
//these functions are called from the install file

//installs content types
function package_builder_install_cck($path) {
  foreach (glob($path . '/cck/*.cck') as $importfile) {
    $file = file_get_contents($importfile);
    $form_state = array();
    $form = content_copy_import_form($form_state);

    $form_state['values']['type_name'] = '<create>';
    $form_state['values']['macro'] = $file;
    $form_state['values']['op'] = t('Import');
    content_copy_import_form_submit($form, $form_state);
  }
}

//installs views
function package_builder_install_views($path) {
  require_once(drupal_get_path('module', 'views') . '/includes/view.inc');
  foreach (glob($path . '/views/*.view') as $importfile) {
    $view = NULL;
    $file = file_get_contents($importfile);
    eval($file);
    if (!$view->name) {
      drupal_set_message("Error importing file $importfile", 'error');
      continue;
    }
    $view->save();
    drupal_set_message('View ' . $view->name . ' added.');
  }
}

//installs roles
function package_builder_install_roles($path) {
  foreach (glob($path . '/roles/*.role') as $importfile) {
    $role = array();

    ob_start();
    include $importfile;
    ob_end_clean();

    package_builder_add_role($role['name']);
    permissions_grant_permissions($role['name'], $role['permissions']);
    drupal_set_message('Role ' . $role['name'] . ' added.');
  }
}

// helper function for package_builder_add_roles
function package_builder_add_role($name) {
  // Check to see if role already exists. If not, create it.
  $rid = db_result(db_query_range("SELECT rid FROM {role} WHERE name ='%s'", $name));
  if (!$rid) {
    db_query("INSERT INTO {role} (name) VALUES ('%s')", $name);
  }
  return;
}

//installs flags
function package_builder_install_flags($path) {
  $file = './'. drupal_get_path('module', 'flag') . '/includes/flag.export.inc';
  require_once($file);
  foreach (glob($path . '/flags/*.flag') as $importfile) {
    $file = file_get_contents($importfile);
    $form_state = array();
    $form = flag_import_form($form_state);
    $form_state['values']['import'] = $file;
    flag_import_form_validate($form, $form_state);
    flag_import_form_submit($form, $form_state);
    //drupal_execute('flag_import_form', $form_state);
  }
}

//installs nodes
function package_builder_install_nodes($path) {
  foreach (glob($path . '/nodes/*.node') as $importfile) {
    $node = array();

    ob_start();
    include $importfile;
    ob_end_clean();

    $temp = new stdClass();
    foreach ($node as $key => $value) {
      $temp->$key = $value;
    }
    node_save($temp);
    drupal_set_message('Node ' . $temp->title . ' added.');
  }
}

//installs rules
function package_builder_install_rules($path) {
  foreach (glob($path . '/rules/*.{rule,ruleset}', GLOB_BRACE) as $importfile) {

    $file = '$import = ' . file_get_contents($importfile) . ';';
    eval($file);

    if (!isset($import) || !is_array($import) || !count($import)) {
      drupal_set_message("Error importing $importfile", 'error');
      continue;
    }

    foreach ($import as $item_type => $elements) {
      foreach ($elements as $name => $element) {
        rules_item_type_invoke($item_type, 'import', array(&$name, &$element));
        rules_item_save($item_type, $name, $element);
        drupal_set_message(t('Rule %label was added.',
                             array('%label' => rules_get_element_label($element))));
      }
    }
  }
  rules_clear_cache();
}

function package_builder_install_users($path) {
  foreach (glob($path . '/users/*.user') as $importfile) {
    $user_ = array();

    ob_start();
    include $importfile;
    ob_end_clean();
    $roles = $user_->roles;
    unset($user_->roles);


    user_save(NULL, $user_);
    drupal_set_message('User ' . $user_['name'] . ' added.');
  }
}

function package_builder_install_vardumps($path) {
  foreach (glob($path . '/vardumps/*.dump') as $importfile) {
    ob_start();
    include $importfile;
    ob_end_clean();
    drupal_set_message(t("Variable dump file $importfile was added."));
  }
}