<?php

//  This is the magic.
//  It's a class that knows how to grab everything
//  out of a table and give it to you in a list.
//  It gets subclassed when we're looking for different things.
//
//  ** most likely get ripped out and replaced with entities in D7 **

class LookUp {
  function __construct($title, $id, $table, $name) {
    $this->title = $title;
    $this->id = $id;
    $this->table = $table;
    $this->name = $name;
    $this->get_all();
    $this->lookup();
  }
  function get_all() {
    $this->all = db_query("SELECT * FROM {%s}", $this->table);
  }
  function get_list() {
    if (count($this->children) == 0) {
      return array();
    }
    return $this->children;
  }
  function get_title() {
    return $this->title;
  }
  function get_id() {
    return $this->id;
  }
  function get_table() {
    return $this->table;
  }
  function get_name() {
    return $this->name;
  }
  function get_disname() {
    return ucfirst($this->name);
  }
  function mod_title($id) {
    return FALSE;
  }
  function lookup() {
    $id = $this->id;
    while ($item = db_fetch_object($this->all)) {
      $title = $this->mod_title($item->$id);
      if ($title == FALSE) {
        $temp = $this->title;
        $title = $item->$temp;
      }
      $a = array();
      $a['title'] = $title;
      $a['id'] = 'package_item--' . $this->table . '--' . $item->$id;
      $a['real_id'] = $item->$id;
      $this->children[] = $a;
    }
  }
}

class NodesLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function get_all() {
    $this->all = db_query("SELECT * FROM {%s} WHERE type NOT IN('package_builder', 'variable_dump')", $this->table);
  }
  function lookup() {
    $id = $this->id;
    while ($item = db_fetch_object($this->all)) {
      $title = $this->mod_title($item->$id);
      if ($title == FALSE) {
        $temp = $this->title;
        $title = $item->$temp;
      }
      $a = array();
      $a['title'] = $title .' - ['. $item->$id . ']';
      $a['id'] = 'package_item--' . $this->table . '--' . $item->$id;
      $a['real_id'] = $item->$id;
      $this->children[] = $a;
    }
  }
}

class VarDumpLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function get_all() {
    $this->all = db_query("SELECT * FROM {%s} WHERE type='variable_dump'", $this->table);
  }
  function get_disname() {
    return 'Vardumps';
  }
  function lookup() {
    $id = $this->id;
    while ($item = db_fetch_object($this->all)) {
      $title = $this->mod_title($item->$id);
      if ($title == FALSE) {
        $temp = $this->title;
        $title = $item->$temp;
      }
      $a = array();
      $a['title'] = $title .' - ['. $item->$id . ']';
      $a['id'] = 'package_item--' . 'vardumps' . '--' . $item->$id;
      $a['real_id'] = $item->$id;
      $this->children[] = $a;
    }
  }
}

class ModulesLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function get_all() {
    $this->all = module_list(TRUE, FALSE, FALSE);
    $remove = array('views', 'content', 'rules', 'permissions_api', 'flag',
                    'filter', 'user', 'system', 'block', 'node');
    foreach ($this->all as $key => $value) {
      if (in_array($value, $remove)) {
        unset($this->all[$key]);
      }
    }
  }
  function lookup() {
    foreach ($this->all as $mod) {
      $a = array();
      $a['title'] = $mod;
      $a['id'] = 'package_item--' . $this->table . '--' . $mod;
      $a['real_id'] = $mod;
      $this->children[] = $a;
    }
  }
}

class BlocksLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function mod_title($id) {
    $res = db_query("SELECT module,delta FROM {%s} WHERE bid= '%s'", $this->table, $id);
    $obj = db_fetch_object($res);
    return $obj->module . ' ' . $obj->delta;
  }
}

class RulesLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function mod_title($id) {
    $data = db_result(db_query("SELECT data FROM {%s} WHERE name= '%s'", $this->table, $id));
    $res = unserialize($data);
    $categories = implode(',', $res['#categories']);
    if ($categories) {
      return '('.$categories.')'. $res['#label'] . ' [' . $id . ']';
    }
    else {
      return $res['#label'] . ' [' . $id . ']';
    }
  }
  function lookup() {
    $id = $this->id;
    while ($item = db_fetch_object($this->all)) {
      $data = unserialize($item->data);
      $test = StartsWith($data['#set'], 'rules_');
      if ($test) {
        continue;
      }
      $categories = implode(',', $data['#categories']);
      if ($categories) {
        $label = '('.$categories.')'. $data['#label'] . ' [' . $item->name . ']';
      }
      else {
        $label = $data['#label'] . ' [' . $item->name . ']';
      }
      $a = array();
      $a['title'] = $label;
      $a['id'] = 'package_item--' . $this->table . '--' . str_replace(' ', '$$%$$', $item->$id);
      $a['real_id'] = $item->$id;
      $this->children[] = $a;
    }
  }
}


class RulesSetsLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function mod_title($id) {
    $data = db_result(db_query("SELECT data FROM {%s} WHERE name= '%s'", $this->table, $id));
    $res = unserialize($data);
    $categories = implode(',', $res['categories']);
    if ($categories) {
      return '('.$categories.')'. $res['label'];
    }
    else {
      return $res['label'];
    }
  }
}

class UsersLookUp extends LookUp {
  function __construct($title, $id, $table, $name) {
    parent::__construct($title, $id, $table, $name);
  }
  function mod_title($id) {
    if ($id == 0) {
      return 'anonymous';
    }
    else {
      return FALSE;
    }
  }
}

//  Here we instantiate the classes and add them to the $supported array


$supported = array();
$node_ = new NodesLookUp('title', 'nid', 'node', 'nodes');
$supported[] = $node_;
$vardump_ = new VarDumpLookUp('title', 'nid', 'node', 'vardumps');
$supported[] = $vardump_;
$views_ = new LookUp('name', 'name', 'views_view', 'views');
$supported[] = $views_;
$flags_ = new LookUp('title', 'name', 'flags', 'flags');
$supported[] = $flags_;
$rules_ = new RulesLookUp('name', 'name', 'rules_rules', 'rules');
$supported[] = $rules_;
$rules_sets_ = new RulesSetsLookUp('name', 'name', 'rules_sets', 'rule sets');
$supported[] = $rules_sets_;
$roles_ = new LookUp('name', 'rid', 'role', 'roles');
$supported[] = $roles_;
$modules_ = new ModulesLookUp('none', 'none', 'module', 'modules');
$supported[] = $modules_;

//  Blocks are supported here but not anywhere else.
//  Not sure what to do, if anything.
//$blocks_ = new BlocksLookUp('module', 'bid', 'blocks', 'blocks');
//$supported[] = $blocks_;
$users_ = new UsersLookUp('name', 'uid', 'users', 'users');
$supported[] = $users_;
$cck_ = new LookUp('name', 'type', 'node_type', 'content types');
$supported[] = $cck_;
//$menu_ = new LookUp('menu_name', 'mlid', 'menu_links', 'menus');
//$supported[] = $menu_;
